# This module, and all included code, is made available under the terms of the MIT Licence
#
# Copyright (c) 2023 David Love
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

"""Examples for the library use: mostly as _incomplete_ code fragments and
demonstrations.

Overview
--------

This is a collection of examples, utility classes and other scraps of code which
demonstrate the use of the library in common applications. Many of these
examples will require extension, or further development in real applications.
However they should give some idea of what those more complete applications may
look like.

Demonstrations
--------------

Many of the examples require a working board to reproduce, and so where possible
examples have been provided on [WokWi](https://wokwi.com/).

Current demonstrations are

* `lbutils.drivers.seven_segment.SegDisplay`: [7-Segment Display](https://
wokwi.com/projects/360451068863047681)
* `lbutils.drivers.seven_segment_hex.SegHexDisplay`: [7-Segment Hex Digits
Display](https://wokwi.com/projects/360462223276690433)

Tested Implementations
----------------------

This version is written for MicroPython 3.4, and has been tested on:

  * Raspberry Pi Pico H/W
"""

__pdoc__ = {"seven_segment_example": False, "seven_segment_hex_example": False}
